#ifndef HATPCONNECTION_HPP
#define HATPCONNECTION_HPP

#include <string>


#include "../taskManagerInterface.hpp"

class taskManagerInterface;
extern taskManagerInterface* TMI;

//! @ingroup KINECT
//! Kinect joint
struct HumanJoint {
  p3d_vector3   pos;
  double        confidence;
};

//! @ingroup KINECT
//! Only HEAD, NECK, TORSO,
//! SHOULDERS, ELBOW,
//! HAND, HIP, KNEE and FOOT
struct HumanJoints
{
  HumanJoint HEAD, NECK, TORSO;
  HumanJoint SHOULDER_RIGHT;
  HumanJoint SHOULDER_LEFT;
  HumanJoint ELBOW_RIGHT;
  HumanJoint ELBOW_LEFT;
  HumanJoint HIP_LEFT;
  HumanJoint HIP_RIGHT;
  HumanJoint HAND_RIGHT;
  HumanJoint HAND_LEFT;
  HumanJoint KNEE_RIGHT;
  HumanJoint KNEE_LEFT;
  HumanJoint FOOT_RIGHT;
  HumanJoint FOOT_LEFT;
};



class HATPConnection
{
public:
    HATPConnection();

    bool connectMsgConnector();

    const std::string& interpreteJson(const std::string& u);
    configPt getConfFromJointsPos( p3d_rob* robot, HumanJoints& data );

    /**
      * read the file with the given path
      * this file must be under json format, with all the commands numbered starting from 0:
      * { "0": {command}, "1":{another command}, ... }
      * note: each command is interpreted using interpreteJson()
      */

    void readFromFile(std::string path);


private:
    std::string _result;
};

#endif // HATPCONNECTION_HPP
