#include "onePlan.hpp"

using namespace std;

OnePlan::OnePlan()
{

}

OnePlan::~OnePlan()
{

}

OnePlan::OnePlan(PlanTree* PT)
{
    _PT = PT;
    _plan.clear();
}

void OnePlan::addToPlan(PlanNode* PN)
{
    if (_plan.size() == 0)
    {
        cout << "plan size 0 " << endl;
        _plan.push_back(PN);
    }
    vector<PlanNode*> vpn;

    if (!PN->getPrevious())
    {
        cout << "ERROR, no previous for this node " << PN->getId().first << " , " << PN->getId().second << endl;
        return;
    }
    if (PN->getPrevious()->getId().first == _plan.at(_plan.size()-1)->getId().first
            && PN->getPrevious()->getId().second == _plan.at(_plan.size()-1)->getId().second )
    {
        _plan.push_back(PN);
    }
    else
    {
        PlanNode* pnTmp = PN;
        while(pnTmp)
        {
//            cout << "pnTmp id = " << pnTmp->getId().first << " , " << pnTmp->getId().second << endl;
            vpn.push_back(pnTmp);
            pnTmp = pnTmp->getPrevious();
        }
        _plan.clear();
        for(unsigned int i = vpn.size(); i > 0; i--)
        {
            _plan.push_back(vpn.at(i-1));
        }
    }
}

void OnePlan::printPlan()
{
    cout << "printing plan:" <<endl;
    cout << "number of nodes = " << _plan.size() << endl;

    for (unsigned int i = 0 ; i < _plan.size(); i++)
    {
        cout << "node Id = (" << _plan.at(i)->getId().first << " , " <<  _plan.at(i)->getId().second << ")" << endl;
        if (_plan.at(i)->getPrevious())
            cout << "    with previous node with Id (" << _plan.at(i)->getPrevious()->getId().first << " , " <<  _plan.at(i)->getPrevious()->getId().second << ")" << endl;
        else
            cout << "    first in the tree" << endl;
    }
}

void OnePlan::removeLast()
{
    vector<PlanNode*> tmp;
    for (unsigned int i = 0; i < _plan.size()-1; i++)
    {
        tmp.push_back(_plan.at(i));
    }
    _plan = tmp;
}

TaskSolution* OnePlan::getLastSol()
{
    if(_plan.size()== 0)
        return NULL;
    return _plan.at(_plan.size()-1)->getTaskSolution();
}
