#include "planNode.hpp"
#include "taskSolution.hpp"
#include "GTP/Tasks/task.hpp"

using namespace std;

PlanNode::PlanNode()
{
    _TS =NULL;
}

PlanNode::~PlanNode()
{

}

PlanNode::PlanNode(PlanTree* PT, TaskSolution* TS)
{
    _PT = PT;
    _TS = TS;
    _suceeded = true;
    if (!_TS)
        _suceeded = false;
    _previous =NULL;

    SD = new SolutionData();

    SD->getSDMapEntry("statistics")->setMapEntry("nbGikCalled", -1);
    SD->getSDMapEntry("statistics")->setMapEntry("nbMPCalled", -1);
    SD->getSDMapEntry("statistics")->setMapEntry("nbParameters", -1);
    SD->getSDMapEntry("statistics")->setMapEntry("nbTotPossibleTests", -1);
    SD->getSDMapEntry("statistics")->setMapEntry("nbTests", -1);
    SD->getSDMapEntry("times")->setMapEntry("timeComp", -1.5);
    SD->getSDMapEntry("times")->setMapEntry("timeMp", -1.5);
    SD->getSDMapEntry("graph")->setMapEntry("nbGraphNode", -1);
    SD->getSDMapEntry("graph")->setMapEntry("nbComputedNodes", -1);
    SD->getSDMapEntry("graph")->setMapEntry("trajSize", -1.5);
    SD->getSDMapEntry("backtrackingData");
    SD->setMapEntry("returnReport", "");

}

bool PlanNode::setPrevious(PlanNode* PN)
{
    //check if previous has same WS as this one
//    if (PN->getTaskSolution()->getStopWS()->isEqualTo(getTaskSolution()->getStartWS()))
//    {
        _previous = PN;
        if (PN)
            PN->addToNexts(this);
//        return PN->addToNexts(this);
//    }
//    return false;
        return true;
}

double PlanNode::getDuration()
{

    return _TS->getDuration();
}

bool PlanNode::isInNexts(PlanNode* PN)
{
    for (unsigned int i = 0; i < _nexts.size(); i ++)
    {
        PlanNode* tmp = _nexts.at(i);
        if (tmp->getId().first == PN->getId().first && tmp->getId().second == PN->getId().second)
        {
            return true;
        }
    }
    return false;
}

pair<int,int> PlanNode::getId()
{
    pair<int,int> iid;
    if (hasSucceeded() && _TS)
    {
        iid.first = _TS->getTask()->getId();
        iid.second = _TS->getId();
    }
    else
    {
        iid.first = -10;
        iid.second = -10;
    }
    return iid;
}

bool PlanNode::addToNexts(PlanNode* PN)
{
    if (PN->hasSucceeded())
        if (!PN->getTaskSolution()->getStartWS()->isEqualTo(getTaskSolution()->getStopWS()))
            return false;
    for (unsigned int i = 0; i < _nexts.size(); i++)
    {
        if (PN->getId().first == _nexts.at(i)->getId().first && PN->getId().second == _nexts.at(i)->getId().second)
        {
            cout << "Node with ID (" << PN->getId().first << " , " << PN->getId().second << ") already exist in nexts list, changing it to the new one" <<endl;
            _nexts[i] = PN;

        }
        else
            _nexts.push_back(PN);
    }
    return true;
}

template < typename T > std::string to_string4( const T& n )
{
    std::ostringstream stm ;
    stm << n ;
    return stm.str() ;
}

string PlanNode::getFormatedNumbers()
{
    return SD->getHumanReadableData();
//    string s = "Important numbers:\n";
//    s += "time = " + to_string4(timeComp) +"\n";make
//    if (getTaskSolution())
//        s+= "cost = " + to_string4(getTaskSolution()->getCost()) + "\n";
//    s += "nb GIK = " + to_string4(nbGikCalled) +"\n";
//    s += "nb MP = " + to_string4(nbMPCalled) +"\n";
//    s += "nb var = " + to_string4(nbParameters) +"\n";
//    s += "nb tests = " + to_string4(nbTests) +"\n";
//    s += "nb Tot Possible Tests = " + to_string4(nbTotPossibleTests) +"\n";
//    s += "return report = " + to_string4(returnReport) +"\n";
//    return s;
}

double PlanNode::computePriority()
{
    map<string,double>::iterator it;
    double res = 0;
    cout << "================= " << getId().first << " " << getId().second << endl;
    for(it = backtrackingData.begin(); it != backtrackingData.end(); it++)
    {
      cout << "key: "<< it->first << " value: " << it->second << endl;
      res+=it->second;
    }
    return res;
}

bool PlanNode::operator==(PlanNode* p)
{
    return (getId().first == p->getId().first && getId().second == p->getId().second);
}
