#ifndef STRUCTTOOLS_H
#define STRUCTTOOLS_H

#include "API/Device/robot.hpp"
#include "graspPlanning/include/gpGrasp.h"

enum TasksId {
    noType, //dummy, in case
    pick,
    pick_multirrt,
    pickHuman,
    place,
    placeHuman,
    place_multirrt,
    placeReachable,
    pickAndPlace,
    makeAccessible,
    pickAndMakeAccessible,
    exhibit,
    pickAndShow,
    give,
    pickAndGive,
    point,
    fix,
    drop,
    navigateTo,
    moveTo,
    stackObj,
    fakePlace,
    pickPlaceQuad,
    pickQuad,
    placeQuad,
    navigateAndPick,
    //this is the last one:
    nbOfTaskId
};

struct Attachement{
    Robot* agent;
    Robot* object;
    gpGrasp grasp;
    int armId;
};

struct SurfaceAttachement{
    Robot* support;
    Robot* attache;
    p3d_matrix4 transform;
    int jointId; //the number of joints starts from 0
};



typedef struct STRUCT_type_data
{
    TasksId id;
    std::multimap<std::string,std::string> agents;
    std::multimap<std::string,std::string> objects;
    std::multimap<std::string,p3d_point> points;
    std::multimap<std::string,std::string> additionalData;

}type_data;

typedef struct STRUCT_Support
{
    Robot* object;
    std::vector<p3d_point> rectangle_corner;
    //TODO: include other kind of shapes
}Support;


//#################### global functions #########################

template < typename T > std::string to_string( const T& n )
{
    std::ostringstream stm ;
    stm << n ;
    return stm.str() ;
}

#endif // STRUCTTOOLS_H
