#include "taskSolution.hpp"

using namespace std;

TaskSolution::TaskSolution(TaskAllSolutions* taskAS, int id)
{
    _TAS = taskAS;
    _TAS->addAlternativeSol(this);

    alternativeId = id;
    _trajComputed = false;
    importantConfsId = 0;

    _start_WS =NULL;
    _end_WS = NULL;

}

TaskSolution::TaskSolution()
{
    _TAS = 0;

    alternativeId = -1;
    _trajComputed = false;
    importantConfsId = 0;

    _start_WS =NULL;
    _end_WS = NULL;
}

TaskSolution::~TaskSolution()
{

}

void TaskSolution::addToSolutions(TaskSubSolution* tss)
{
    for(map<Robot*,vector<TaskSubSolution*> >::iterator it = solutionMap.begin(); it != solutionMap.end(); ++it) {
        string name1 = it->first->getName();
        string name2 = tss->getRobot()->getName();
        if(name1==name2)
        {
            it->second.push_back(tss);
            return;
        }
    }
    vector<TaskSubSolution*> vTSS;
    vTSS.push_back(tss);
    solutionMap[tss->getRobot()] = vTSS;
}

double TaskSolution::getDuration()
{
    return 0;
}

void TaskSolution::addConf(confPtr_t q)
{
    importantConfs.push_back(confPtr_t(new Configuration(*q)));
}

confPtr_t TaskSolution::getNextConf()
{
    confPtr_t q;
    if (importantConfs.size() > 0)
    {
        if (importantConfsId >= importantConfs.size())
            importantConfsId = 0;

        q = importantConfs.at(importantConfsId);
        importantConfsId++;
    }
    return q;
}

TaskSubSolution* TaskSolution::getFirstSubSolution()
{
    TaskSubSolution* TSS = NULL;
    vector<Robot*> v = getInvolvedRobots();
    if (v.size() == 0)
        return TSS;
    TSS = solutionMap.at(v.at(0)).at(0);
    while(TSS->getPrevious().size() > 0)
    {
        TSS = TSS->getPrevious().at(0);
    }
    return TSS;
}

TaskSubSolution* TaskSolution::getNextSubSolution(TaskSubSolution* ts)
{
    //TODO:THIS is a function that shouldn t be used
    return ts->getNext().at(0);
}

TaskSubSolution* TaskSolution::getSubSolutionWithId(int subId)
{
    vector<Robot*> v = getInvolvedRobots();
    for (unsigned int i = 0; i < v.size(); i++)
    {
        vector<TaskSubSolution*> vtss = solutionMap.at(v.at(i));
        for (unsigned int j = 0; j < vtss.size(); j++)
        {
            if (vtss.at(j)->getId() == subId)
            {
                return vtss.at(j);
            }
        }
    }
    TaskSubSolution* tss = NULL;
    return tss;
}

int TaskSolution::getNbsubSolPerRobot(Robot* rob)
{
    return solutionMap.at(rob).size();
}


vector<TaskSubSolution*> TaskSolution::getTSSByRobot(Robot* rob)
{
    return solutionMap.at(rob);
}

vector<TaskSubSolution*> TaskSolution::getAllTSS()
{
    vector<TaskSubSolution*> vrs;
    for(map<Robot*,vector<TaskSubSolution*> >::iterator it = solutionMap.begin(); it != solutionMap.end(); ++it) {

        Robot* rob = it->first;
        vector<TaskSubSolution*> tmp = solutionMap.at(rob);

        for (unsigned int i = 0; i < tmp.size(); i++)
        {
            vrs.push_back(tmp.at(i));
        }

    }
    return vrs;
}

vector<Robot*> TaskSolution::getInvolvedRobots()
{
    vector<Robot*> v;
    for(map<Robot*,vector<TaskSubSolution*> >::iterator it = solutionMap.begin(); it != solutionMap.end(); ++it) {
      v.push_back(it->first);

    }
    return v;
}

Task* TaskSolution::getTask()
{
    return _TAS->getTask();
}

bool TaskSolution::isInPreviousDoneTSS(TaskSubSolution* tss)
{
    for (unsigned int i = 0; i < PreviousDoneTSS.size(); i++)
    {
        if(tss->getId() == PreviousDoneTSS.at(i)->getId())
        {
            return true;
        }
    }
    return false;
}
void TaskSolution::addToPreviousDoneTSS(TaskSubSolution* tss)
{
    PreviousDoneTSS.push_back(tss);
}

void TaskSolution::addTypeData(type_data td)
{
    _TData.agents.insert(td.agents.begin(), td.agents.end());
    _TData.objects.insert(td.objects.begin(), td.objects.end());
    _TData.additionalData.insert(td.additionalData.begin(), td.additionalData.end());
    _TData.points.insert(td.points.begin(), td.points.end());
}

void TaskSolution::clearTypeData()
{
    _TData.agents.clear();
    _TData.objects.clear();
    _TData.additionalData.clear();
    _TData.points.clear();
}
