#ifndef HRICS_CF_TIMETOCOLLISION_H
#define HRICS_CF_TIMETOCOLLISION_H

#include "HRICS_costfunction.h"
#include "HRICS_CF_VirtualCostFunction.h"
#include "Logging/Logger.h"
#include "API/planningAPI.hpp"


namespace HRICS {
namespace CF {

class TimeToCollision : public HRICS::CF::VirtualCostFunction
{
    MOVE3D_STATIC_LOGGER;
public:
    using VirtualCostFunction::getCost;

    TimeToCollision(CostFunctionCommon *commonCF,double min, double max, double low,double up,double maxToMeanRatio, FunctionShape shape);
    virtual ~TimeToCollision();

    static std::string getName(){return "TimeToCollision";}

    double getCost();
    /// rate the last configuration of confs according to its history
    double getCost(std::vector<confPtr_t> &confs, double dt);
    double getCost(API::Trajectory const& traj);
    double getTimeToCollision(confPtr_t cprev, confPtr_t ccurrent, double dt, double maxt);
    confPtr_t  projectConfiguration(confPtr_t cprev, confPtr_t ccurrent, double dt, double t);

    virtual bool isDynamicCost(){return true;}

    static int test(CostFunctionCommon* commonCF);
private:
};

} // namespace CF
} // namespace HRICS

#endif // HRICS_CF_TIMETOCOLLISION_H
