#ifndef HRICS_CF_TORSOHEIGHT_H
#define HRICS_CF_TORSOHEIGHT_H

#include "Logging/Logger.h"
#include "API/planningAPI.hpp"

#include "HRICS_CF_VirtualCostFunction.h"
#include "HRICS_CF_KeepItLow.h"

namespace HRICS {
namespace CF {

class TorsoHeight : public VirtualCostFunction
{
    MOVE3D_STATIC_LOGGER;
public:
    using VirtualCostFunction::getCost;

    TorsoHeight(CostFunctionCommon *commonCF,double min, double max, double low,double up,double maxToMeanRatio, FunctionShape shape);
    virtual ~TorsoHeight();

    double getCost();

    void findJoints();
    void computeLawParam();

    void onHumanMove();

    void setLowerBound(double lowerBound);
    double loweBound() const;

    void setUpperBound(double upperBound);
    double upperBound() const;

    static std::string getName();

private:

    KeepItLow * _keepItLow;

    std::vector<Joint*> _shoulders,_pelvises;
};

} // namespace CF
} // namespace HRICS

#endif // HRICS_CF_TORSOHEIGHT_H
