#include "HRICS_FaceHumans.h"
#include "utils/Geometry.h"
#include "HRICS_costfunction.h"

namespace HRICS {
namespace CF {

FaceHumans::FaceHumans(CostFunctionCommon *commonCF, double min, double max, double low, double up, double maxToMeanRatio, FunctionShape shape):
    VirtualCostFunction(commonCF,min,max,low,up,maxToMeanRatio,shape)
{

}

FaceHumans::~FaceHumans()
{

}

double FaceHumans::getCost(){
    std::vector<double> angles; // e.g., 0 when facing, PI when human is in the back of the robot
    Robot *human,*rob;
    rob=_common->getRobot();
    Eigen::Vector2d rob_pos = m3dGeometry::getConfBase2DPos(*rob->getCurrentPos());
    for(unsigned int h=0;h<_common->getHumans().size();h++){
        std::map<HRI_AGENT_TYPE,std::vector<std::pair< int,double> > >::const_iterator humanweights,rweights;
        human=_common->getHumans()[h];
        angles.push_back(0);
    }

    return 0;
}

} // namespace CF
} // namespace HRICS

