#include "HRICS_CostSettingType.h"
#include <algorithm>

namespace HRICS {

std::vector<std::string> CostSettingType::__stringValues =std::vector<std::string>(0);
CostSettingType::CostSettingType():
    _value(-1)
{
}

CostSettingType::CostSettingType(const std::string &s)
{
    std::vector<std::string>::const_iterator it=std::find(CostSettingType::__stringValues.begin(),__stringValues.end(),s);
    if (it!=CostSettingType::__stringValues.end()){
        this->_value=it-__stringValues.begin();
    }else{
        __stringValues.push_back(s);
        this->_value=__stringValues.size()-1;
    }
}

CostSettingType::~CostSettingType()
{
}

CostSettingType CostSettingType::getDefault()
{
    return CostSettingType("default");
}

std::string CostSettingType::toString() const
{
    if(isDefined()){
        return __stringValues[this->_value];
    }else{
        return "undef!";
    }
}

bool CostSettingType::isDefined() const
{
    if(_value >=0 ){
        return true;
    }else{
        return false;
    }
}
} // namespace HRICS

