#ifndef ENT_VIRTUAL_H
#define ENT_VIRTUAL_H

#include "API/Device/robot.hpp"
#include <jsoncpp/json/json.h>

#include "Logging/Logger.h"


namespace Ent {


/**
  * @brief Virtual distinguish between virtual and normal objects
  *
  * usefile: EntityTypes/Virtual.json
  */
class Virtual
{
    MOVE3D_STATIC_LOGGER;
public:
    Virtual( std::string global_json_path);
    ~Virtual();


    //json import/export
    //.global
    std::string getPath();

    //.import
    bool fetchData();
    bool importJsonFile(const std::string &path);
    bool createVirtualObjects(Json::Value const & value);

    //.json conversion
    bool setToObjRob(Robot *rob);


private:
    std::string _global_json_path;
};

} // namespace Ent

#endif // ENT_VIRTUAL_H
