#ifndef SEM_AGENTTYPE_H
#define SEM_AGENTTYPE_H

#include "API/Device/robot.hpp"
#include <string>
#include <vector>
#include <map>


namespace Sem {

class AgentType
{
public:
    AgentType();
    AgentType(HRI_AGENT_TYPE t);
    AgentType(std::string s);
    virtual ~AgentType();

    static AgentType fromRobot(Robot *rob);

    bool isDefined() const;

    static bool getAgentTypeFromStr(std::string const &s, HRI_AGENT_TYPE &type);
    static bool getStrAgentType(HRI_AGENT_TYPE type,std::string &s);

    static std::string agentTypeToString(HRI_AGENT_TYPE type);
    static std::string agentTypeToHumanString(HRI_AGENT_TYPE type);

    friend bool operator==(const AgentType &t1, const AgentType &t2);
    friend bool operator!=(const AgentType &t1, const AgentType &t2);
    friend bool operator<(const AgentType &t1, const AgentType &t2);
    friend bool operator>(const AgentType &t1, const AgentType &t2);

    HRI_AGENT_TYPE toHriAgentType() const ;
    std::string toString() const ;

private:
    static std::map<HRI_AGENT_TYPE,std::string> _agent_types_str;

    HRI_AGENT_TYPE _val;
    bool _isDef;
};

} // namespace Sem

#endif // SEM_AGENTTYPE_H
