/*
 * DirectedRRT.hpp
 *
 *  Created on: Jan 2015
 *      Author: aboeuf
 */

#ifndef DIRECTED_RRT_HPP
#define DIRECTED_RRT_HPP

#include "planner/Diffusion/RRT.hpp"

class DirectedExpansion : public RRTExpansion {

public:

    DirectedExpansion(Graph * graph) : RRTExpansion(graph){
        _expandGoalTree=false;
    }

    virtual ~DirectedExpansion(){}

    bool expandGoalTree();
    void switchTrees();
    unsigned extend(Node * fromNode,confPtr_t directionConf,Node * directionNode);
    unsigned connect(Node * fromNode,confPtr_t directionConf,Node * directionNode);
    Node* addNode(localPathPtr_t path, Node * fromNode, Node * directionNode);
    bool addCycles();

private:
    bool _expandGoalTree;

};

class DirectedRRT : public RRT {

public:

    DirectedRRT(Robot *robot,Graph *graph) : RRT(robot, graph) {
        std::cout<<"Construct the DirectedRRT"<<std::endl;
    }
    virtual ~DirectedRRT(){}

    unsigned init();
    unsigned run();
    bool trajFound();
    unsigned expandOneStep(ConnectedComponent * fromComp);
    bool checkStopConditions();

private:

    void updateConnections();
    void pause();

};



#endif
