#ifndef TRAJEVAL_H
#define TRAJEVAL_H

#include <boost/function.hpp>
#include "API/Trajectory/trajectory.hpp"
#include "Logging/Logger.h"


class TrajEval
{
    MOVE3D_STATIC_LOGGER;
public:
    TrajEval();
    double evaluate(API::Trajectory & traj);

    static double maximum(API::Trajectory &t, std::vector<boost::function<double(API::Trajectory&)> > &funcs);
    static double sum(API::Trajectory &t, std::vector<boost::function<double(API::Trajectory&)> > &funcs);
    static double alpha(API::Trajectory &t,double a,boost::function<double(API::Trajectory &)> &f);

    /// see example
    static boost::function<double(API::Trajectory&)> getTrajFunction(std::string name);
    static double traj_cost(API::Trajectory &t, std::string &fx_name);

    static double example(API::Trajectory &t);
    static void run_example();


private:
    std::vector<boost::function<double(API::Trajectory&)> > _min_operands_f, _max_operands_f, _sum_operands_f; ///< lists of functions given as operands to min, max and sum in the evaluation

};

#endif // TRAJEVAL_H
